Iannix {
	var <responders, <iannixAddress, <objects, <>groups, <>globalActions, <transportActions, <transportFunctions, <>idOffsets, <messagePeriods;
	var <speed;
	var <synthGroup, <synths, <>t_warned, <>c_warned;
	
	*new { |iannixIP = "127.0.0.1", iannixPort = 1234|
		^super.new.init(iannixIP, iannixPort);
	}
	
	createDictionaries {
		objects = (triggers: (), cursors:(), curves:());
		groups = ();
		globalActions  = (
			triggers: {t_warned ?? {"no trigger action defined".warn; t_warned=true}},
			 cursors: {c_warned ?? {"no cursor action defined".warn; c_warned=true}} 
		);
		responders = ();
		transportFunctions = ();
		[\play, \stop, \fastrewind].do {|message| transportFunctions[message] = {("iannix: " + message).inform; transportActions[message].value } };
		transportActions = (\play: {synthGroup !? {synthGroup.run(true)} }, \stop: {synthGroup !? {synthGroup.run(false)}}, \fastrewind: {synthGroup !? {synthGroup.run(false)}});
		idOffsets = (\triggers: 2000, \curves: 1000, \cursors: 0);
		messagePeriods = (\trigger: 1, \cursor: 20)
	}
	
	init {|ip, iannixPort |
		this.createDictionaries;
		speed = 1;
//		this.connect(ip, iannixPort);
	}
	
	connect  {|ip = "127.0.0.1", port = 1234, sc_server|
		iannixAddress !? {iannixAddress.disconnect};
		iannixAddress = NetAddr(ip, port);
		this.listen(\transport);
//		this.createSynthGroup(sc_server ? Server.default); 
//		^this;
	
	}
		
	listen { |type = \triggers, on = true|
			var typeMsg, oscPrefix, removeMsg, message, object, objectID, action, cutS;
			removeMsg = (type.asString + "Responder Removed");
	
		    responders[type] !? {responders[type].remove;  };
		    if (on) {
		    typeMsg = type.asString;
		    if (type != \transport) {typeMsg = typeMsg[..typeMsg.size-2]};//truncating ending 's'
		    oscPrefix = ("\/"++typeMsg).asSymbol;
		    ("Iannix: listening to" + type++"...").inform;
			responders[type] = OSCresponderNode(iannixAddress, oscPrefix, { | time, responder, msg | //I don't get it, but putting iannixAdress here does work...
				message = msg[1..];
				if (oscPrefix != '/transport' )
				{
					objectID = message.first.asInteger;
					object = objects[type][objectID];
					object ?? { object = IannixObject.preNew(typeMsg, this, objectID) };
					
					action = object.action ? globalActions[type];
					action.(message);
				}
				{
					transportFunctions[message[0]].value;
//					[\triggers, \cursors, \curves].do {|type|
//						var family ;
//						family = objects[type];
//						if (family.isEmpty.not)
//							{i = family.keys.asArray.sort.last+1 }
//							{i = idOffsets[type]}
//						id = i.asInteger; 
//						objects[type][id] = this;
				}
			}).add;
		    }{ removeMsg.inform };
		this.add2cmdPeriod({ responders[type].remove; removeMsg.inform; this.stop});
		^this;

	}
	
	removeResponders {
		responders.do {|resp| resp.remove };
		responders = ();
		
		}
	removeAll {
		this.removeResponders;
		this.createDictionaries;
	}
	
	resetScore {|zoom=100|
		objects.do {|dict| dict.do {|innerObject| innerObject.remove} }; //objects in Iannix.app
		this.zoom_(zoom);
		this.removeAll;//remove local representations of iannix objects, and responders
	}
	
	createSynthGroup {|server|
		server ?? { server = Server.default };
		server.waitForBoot ({
			synthGroup ?? {synthGroup = Group.new};
			("Iannix: new synth group created ("++ synthGroup.nodeID ++"). transport actions operate on it (run true, false)").inform;
			synthGroup.run(false);
		});
		this.add2cmdPeriod({ synthGroup !? { synthGroup = nil; "iannix synth group deleted".inform } });
		^this;
		
	}
	
	add2cmdPeriod { | func |
		CmdPeriod.add(func);
	}

	//transport 
	
	play {|speed|
		speed !? {this.speed = speed};
		iannixAddress.sendMsg("/iannix/play", this.speed);
		transportFunctions[\play].value;
	}
	stop {
		iannixAddress.sendMsg("/iannix/stop");
		transportFunctions[\stop].value;
	}
	fastrewind {
		iannixAddress.sendMsg("/iannix/fastrewind");
		transportFunctions[\fastrewind].value;
	}
	
	speed_ {|value=1|
		iannixAddress.sendMsg("/iannix/speed", value);
		speed = value;
	}
	
	//general commands
	
	zoom_ {|value=100|
		iannixAddress.sendMsg("/iannix/zoom", value);
	}
	
	center_ {|x=0, y=0|
		iannixAddress.sendMsg("/iannix/center", x, y);
	}
		
	//objects
	
	/* 
	(useful for mirroring the existing iannix.app objects, until iannix team implement a dump message for us)
	//put send=false to register (in sc)  any object already existing in IanniX.app
	*/
	
	triggers {
		^this.objects[\triggers];
	}
	
	curves {
		^this.objects[\curves];
	}
	
	cursors {
		^this.objects[\cursors];
	}

	//creation
	trigger {| xPos=0, yPos=0, zPos=0, send = true | 
		var trg;
		trg = IannixTrigger(this);
		if (send) { trg.send; trg.position_(xPos, yPos, zPos) };
		^trg;
	}
	
	curve {|pointsArray, beziers, xPos=0, yPos=0, zPos=0, send = true| //if pointsArray, a curve is added in Iannix
		var crv;
		crv = IannixCurve(this);
		if (send) { 
			crv.send;
			crv.points_(pointsArray, beziers);
			crv.position_(xPos, yPos, zPos) ;
		};		
		^crv;
	}

	cursor {|curve, send = true |
		var crs;
		crs = IannixCursor(this);
		if (send) {
			crs.send;
			crs.putOnCurve(curve)
			};
		^crs;
	}
	
	active {|bool=true, groupName|
		groupName ?? { groupName = "all" };
		iannixAddress.sendMsg("/iannix/setActive", groupName, if (bool){1}{0} )
	}
		
		
}